<?php
class Gallerix {
    
    private static $enqueued_scripts = false;
    
    public static function unique() {
        $chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $string = '';
        for ($i = 0; $i < 10; $i++) {
            $pos = rand(0, strlen($chars) - 1);
            $string .= $chars{$pos};
        }
        return "GALLERIXID_" . $string;
    }

    public static function enqueue_scripts() {
        
        /* enqueue once */
        if (self::$enqueued_scripts === true) return;
        
        /* 
         * Enqueues front-end scripts and styles
         */
        
        wp_enqueue_style("font-awesome", "//netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css");
        wp_enqueue_style('gallerix-site-display-style', plugins_url( 'site/css/display.css', GALLERIX_FILE ));
        wp_enqueue_script('gallerix-site-images-loaded-js', plugins_url( 'site/js/imagesloaded.js', GALLERIX_FILE ), array("jquery"));
        wp_enqueue_script('gallerix-site-easing-js', plugins_url( 'site/js/jquery.easing.js', GALLERIX_FILE ), array("jquery"));
        wp_enqueue_script('gallerix-site-display-js', plugins_url( 'site/js/display.js', GALLERIX_FILE ), array("jquery"));
        
        $options = self::get_options();
        $defaultcat = $options->defaultcat;
        
        wp_localize_script('gallerix-site-display-js', 'gallerixdefaultcat', "$defaultcat");
        add_action('wp_head', 'gallerix_general_settings_styles');
        
        self::$enqueued_scripts = true;
    }
    
    public static function delete_category() {
        global $wpdb;
        global $table_prefix;
        $id = (int)$_GET["catid"];
        if ($id <= 0) return new WP_Error("broke", "Unable to delete category!");
        $query = $wpdb->query(
            $wpdb->prepare(
            "
                DELETE FROM {$table_prefix}gallerix_categories
                WHERE id = %d
            ", $id
            )
        );
                
        if ($query === false) {
            return new WP_Error("broke", "Unexpected error occured while deleting the category!");
        }
        
        $query = $wpdb->query(
            $wpdb->prepare(
            "
                DELETE FROM {$table_prefix}gallerix_images
                WHERE category = %d
            ", $id
            )
        );
                
        if ($query === false) {
            return new WP_Error("broke", "Unexpected error occured while deleting the category images!");
        }
    }
    
    public static function create_category() {
        global $wpdb;
        global $table_prefix;
        $title  = stripslashes($_POST["title"]);
        $update = isset($_POST["update"]) ? $_POST["update"] : false;
        
        if (!$title) return new WP_Error("broke", "Category must have title!");
        
        if ($update) :
            $id = (int) $update;
            if ($id <= 0) return false;
            $query = $wpdb->update(
                "{$table_prefix}gallerix_categories", array(
                "title" => "{$title}"
                ),
                array('id' => $id),
                array(
                    '%s'
                )
            );
        else :
            $query = $wpdb->insert(
                "{$table_prefix}gallerix_categories", array(
                "title" => "{$title}"
                ),
                array(
                    '%s'
                )
            );
        endif;
        
        if ($query === false) :
            return new WP_Error("broke", "Unexpected error occured while creating the category!");
        endif;
    }
    
    public static function get_categories() {
        global $wpdb;
        global $table_prefix;
        $categories = $wpdb->get_results("SELECT * FROM {$table_prefix}gallerix_categories order by `order` ");
        return !empty($categories) ? $categories : array();
    }
    
    public static function get_category() {
        $id = isset($_GET["id"]) ? (int) $_GET["id"] : 0;
        if ($id <= 0) return false;
        global $wpdb;
        global $table_prefix;
        $category = $wpdb->get_results("SELECT * FROM {$table_prefix}gallerix_categories WHERE id = $id");
        return !empty($category) ? $category[0] : false;
    }
    
    public static function get_images() {
        global $wpdb;
        global $table_prefix;
        $images = $wpdb->get_results("SELECT * FROM {$table_prefix}gallerix_images ORDER BY `order` ");
        return !empty($images) ? $images : array();
    }
    
    public static function get_image() {
        $id = isset($_GET["id"]) ? (int) $_GET["id"] : 0;
        if ($id <= 0) return false;
        global $wpdb;
        global $table_prefix;
        $image = $wpdb->get_results("SELECT * FROM {$table_prefix}gallerix_images WHERE id = $id");
        return !empty($image) ? $image[0] : false;
    }
    
    public static function delete_image() {
        global $wpdb;
        global $table_prefix;
        $id = isset($_GET["id"]) ? (int) $_GET["id"] : 0;
        if ($id <= 0) return new WP_Error("broke", "Unable to delete image!");
        $query = $wpdb->query(
        $wpdb->prepare(
            "
            DELETE FROM {$table_prefix}gallerix_images
            WHERE id = %d
            ", $id
            )
        );
            
        if ($query === false) :
            return new WP_Error("broke", "Unexpected error occured while deleting the image!");
        endif;
    }
    
    public static function create_image(){
        global $wpdb;
        global $table_prefix;
        
        $title         = stripslashes($_POST["title"]);
        $category      = stripslashes($_POST["category"]);
        $image         = stripslashes($_POST["image"]);
        $thumb         = stripslashes($_POST["thumb"]);
        $update        = isset($_POST["update"]) ? stripslashes($_POST["update"]) : false;
        
        if (!$image) {
            return new WP_Error("broke", "No image selected!");
        }
        
        if (!$category) {
            return new WP_Error("broke", "Select image category!");
        }
        
        if ($thumb == "") {
            $image_id = self::get_image_id($image);
            $thumb    = wp_get_attachment_image_src($image_id, "gallerix-thumb");
            $thumb    = self::regenerate_thumb($thumb, $image_id);
            $thumb    = $thumb[0];
        } 
        
        if ($update) :
            $id = (int) $update;
            if ($id <= 0) return false;
            $query = $wpdb->update(
                "{$table_prefix}gallerix_images", array(
                "title"       => "{$title}",
                "category"    => "{$category}",
                "image"       => "{$image}",
                "thumb"       => "{$thumb}",
                "order"       => "0"
                ),
                array('id' => $id),
                array(
                    '%s',
                    '%d',
                    '%s',
                    '%s',
                    '%d'
                )
            );
        else :
            $query = $wpdb->insert(
                "{$table_prefix}gallerix_images", array(
                "title"      => "{$title}",    
                "category"   => "{$category}",
                "image"      => "{$image}",
                "thumb"      => "{$thumb}",
                "order"      => "0"
                ),
                array(
                    '%s',
                    '%d',
                    '%s',
                    '%s',
                    '%d'
                )
            );
        endif;
        
        if ($query === false) {
            return new WP_Error("broke", "Unexpected error occured while creating image!");
        }
    }
        
    private static function get_image_id($image_url) {
        global $wpdb;
        $attachment = $wpdb->get_col($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE guid='%s';", $image_url));
        return $attachment[0];
    }
    
    private static function regenerate_thumb($thumb = false, $image_id) {
        if (!$thumb) return;
        if (!$image_id) return;
        $id = $image_id;
        
        if (($thumb[1] !== 240 || $thumb[2] !== 170) && function_exists('add_image_size')) :
            $regenimage = get_post($id);
            if (!$regenimage || 'attachment' != $regenimage->post_type || 'image/' != substr($regenimage->post_mime_type, 0, 6)) {
                return new WP_Error("broke", "Unexpected error occured while regenerating image! File not an image?");
            }
            $fullsizepath = get_attached_file($regenimage->ID);
            if (false === $fullsizepath || !file_exists($fullsizepath)) {
                return new WP_Error("broke", "Unexpected error occured while regenerating image! Image does not exist?");
            }
            $metadata = wp_generate_attachment_metadata($regenimage->ID, $fullsizepath);
            if (is_wp_error($metadata)) {
                return new WP_Error("broke", $metadata->get_error_message());
            }
            if (empty($metadata)) {
                return new WP_Error("broke", "Unknown error occured while regenerating image!");
            }
            wp_update_attachment_metadata($regenimage->ID, $metadata);
            $thumb = wp_get_attachment_image_src($id, "gallerix-thumb");
        endif;
        
        return $thumb;
    }

    public static function create_image_add_multiple() {
        global $wpdb;
        global $table_prefix;
        
        $images        = $_POST["image"];
        $category      = stripslashes($_POST["category"]);
        
        if (!$category) {
            return new WP_Error("broke", "No category selected!");
        }
        
        if (empty($images)) {
            return new WP_Error("broke", "No images selected!");
        }
        
        foreach ($images as $image) :
            
            $id = self::get_image_id($image);
            
            $image = wp_get_attachment_image_src($id, "full");
            $thumb = wp_get_attachment_image_src($id, "gallerix-thumb");
            $title = "";

            $thumb = self::regenerate_thumb($thumb, $id);

            $query = $wpdb->insert(
                "{$table_prefix}gallerix_images", array(
                "title"      => "{$title}",    
                "category"   => "{$category}",
                "image"      => "{$image[0]}",
                "thumb"      => "{$thumb[0]}",
                "order"      => "0"
                ),
                array(
                    '%s',
                    '%d',
                    '%s',
                    '%s',
                    '%d'
                )
            );
                
            if ($query === false) {
                return new WP_Error("broke", "Unexpected error occured while creating image!");
            }
            
        endforeach;
        
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public static function site_get_categories() {
        global $wpdb;
        global $table_prefix;
        $categories = $wpdb->get_results("SELECT * FROM {$table_prefix}gallerix_categories");
        return !empty($categories) ? $categories : array();
    }
    
    public static function site_get_images() {
        $options    = self::get_options();
        $categoryid = self::site_get_current_category();
        $page       = self::site_get_current_page();
        $perpage    = $options->perpage;
        $offset     = $perpage * $page;
        
        global $wpdb;
        global $table_prefix;
        
        if ($categoryid) :
            $images = $wpdb->get_results("SELECT * FROM {$table_prefix}gallerix_images WHERE category = $categoryid ORDER BY `order` LIMIT {$offset},{$perpage}");
        else :
            $images = $wpdb->get_results("SELECT * FROM {$table_prefix}gallerix_images ORDER BY `order` LIMIT {$offset},{$perpage}");
        endif;
        
        return !empty($images) ? $images : array();
    }
    
    private static function site_get_current_category(){
        $categoryid = (int)$_POST["categoryid"];
        return $categoryid ? $categoryid : null;
    }
    
    public static function site_get_current_page(){
        $page = isset($_POST["page"]) ? (int)$_POST["page"] : 0;
        return $page;
    }
    
    public static function site_get_pages() {
        $categoryid = self::site_get_current_category();
        $perpage    = get_option("gallerixperpage");
        
        global $wpdb;
        global $table_prefix;
        
        if ($categoryid) {
            $pages = $wpdb->query("SELECT * FROM {$table_prefix}gallerix_images WHERE category = $categoryid");
        } else {
            $pages = $wpdb->query("SELECT * FROM {$table_prefix}gallerix_images");
        }
        
        $pages = ceil($pages / $perpage);
        
        return !empty($pages) ? $pages : 0;
    }
    
    public static function get_options() {
        
        $options = (object)array();
        
        $options->defaultcat    = get_option("gallerixdefaultcat", 0);
        $options->perpage       = get_option("gallerixperpage", 8);
        $options->gloss         = get_option("gallerixgloss", 1);
        $options->shadow        = get_option("gallerixshadow", 1);
        $options->boxbg         = get_option("gallerixboxbg", "#ffffff");
        $options->navcolor      = get_option("gallerixnavcolor", "#a9a9a9");
        $options->navcolorhover = get_option("gallerixnavcolorhover", "#000000");
        $options->sharedesc     = get_option("gallerixsharedesc", 1);
        $options->navpos        = get_option("gallerixnavpos", "center");
        
        return $options;
    }
    
    public static function reset_options() {
        delete_option("gallerixdefaultcat");
        delete_option("gallerixperpage");
        delete_option("gallerixgloss");
        delete_option("gallerixshadow");
        delete_option("gallerixboxbg");
        delete_option("gallerixnavcolor");
        delete_option("gallerixnavcolorhover");
        delete_option("gallerixsharedesc");
        delete_option("gallerixnavpos");
    }
    
    public static function update_general_settings() {
        $defaultcat        = isset($_POST["defaultcat"])             ? (int)$_POST["defaultcat"]              : "0";
        $perpage           = isset($_POST["perpage"])                ? (int) $_POST["perpage"]                : "6";
        $gloss             = isset($_POST["gloss"])                  ? (int)$_POST["gloss"]                   : "1";
        $shadow            = isset($_POST["shadow"])                 ? (int)$_POST["shadow"]                  : "1";
        $boxbg             = isset($_POST["boxbg"])                  ? $_POST["boxbg"]                        : "#ffffff";
        $navcolor          = isset($_POST["navcolor"])               ? $_POST["navcolor"]                     : "a9a9a9";
        $navcolorhover     = isset($_POST["navcolorhover"])          ? $_POST["navcolorhover"]                : "#000000";
        $sharedesc         = isset($_POST["sharedesc"])              ? $_POST["sharedesc"]                    : "1";
        $navpos            = isset($_POST["navpos"])                 ? $_POST["navpos"]                       : "center";
            
        update_option("gallerixdefaultcat", $defaultcat);
        update_option("gallerixperpage", $perpage);
        update_option("gallerixgloss", $gloss);
        update_option("gallerixshadow", $shadow);
        update_option("gallerixboxbg", $boxbg);
        update_option("gallerixnavcolor", $navcolor);
        update_option("gallerixnavcolorhover", $navcolorhover);
        update_option("gallerixsharedesc", $sharedesc);
        update_option("gallerixnavpos", $navpos);
    }
    
    public static function order_images() {
        $order = $_POST["order"];
        
        if (empty($order)) return;
        
        global $wpdb;
        global $table_prefix;
        
        foreach ($order as $k) {
            $k = explode(":",$k);
            $p = (int) $k[0];
            $o = (int) $k[1];
            $query = $wpdb->update(
                "{$table_prefix}gallerix_images", 
                array("order" => "{$o}"),
                array("id"    => "{$p}"),
                array('%d'),
                array('%d')
            );
             
            if ($query === false) :
                $wpdb->show_errors();
                return new WP_Error("broke", "SQL Error: " . $wpdb->last_error);
            endif;
        }
    }
    
    
    /*
     * Categories ordering
     */
    public static function order_categories() {
        $order = $_POST["order"];
        
        if (empty($order)) return;
        
        global $wpdb;
        global $table_prefix;
        
        foreach ($order as $k) {
            $k = explode(":",$k);
            $p = (int) $k[0];
            $o = (int) $k[1];
            $query = $wpdb->update(
                "{$table_prefix}gallerix_categories", 
                array("order" => "{$o}"),
                array("id"    => "{$p}"),
                array('%d'),
                array('%d')
            );
             
            if ($query === false) :
                $wpdb->show_errors();
                return new WP_Error("broke", "SQL Error: " . $wpdb->last_error);
            endif;
        }
    }
    
}