<h4>Add Multiple Images</h4>
<div class="separator"></div>

<div class="gallerix_create_image_add_multiple">
    
    <form action="?page=<?php echo $plugin_page; ?>&view=list" method="POST">
        
        <label for="image_category">
            Select Target Image Category <span>(Required)</span>
        </label>
        
        <select id="image_category" name="category">
        <?php
            $categories = Gallerix::get_categories();
            $catid      = isset($_GET["catid"]) ? (int) $_GET["catid"] : 0;
            foreach ($categories as $category) :
            ?>
                <option value="<?php echo $category->id; ?>" <?php echo ($category->id == $catid) ? 'selected="selected"' : null;?>><?php echo htmlspecialchars($category->title);?></option>
            <?php
            endforeach;
        ?>
        </select>
        <div class="required_tooltip">This field is required!</div>
        
        <div class="separator"></div>
        
        <label for="gallerix_dates_filter">
            Filter Wordpress Media Library images by Month, Year
        </label>
        
        <select id="gallerix_dates_filter" name="dates">
            <option value="<?php echo "?page=$plugin_page&view=add_multiple&catid=$catid"?>">-- All --</option>
        <?php
            $dates  = Gallerix::get_medialib_dates();
            $filter = isset($_GET["filter"]) ? $_GET["filter"] : "";
            
            foreach ($dates as $k => $date) :
            ?>
                <option <?php echo $filter == $date ? "selected" : null ?> value="<?php echo "?page=$plugin_page&view=add_multiple&catid=$catid&filter=$date"?>"><?php echo $k; ?></option>
            <?php
            endforeach;
        ?>
        </select>
        
        <div class="space"></div>
        
        <div class="gallerix_medialib_select_all"></div>
        
        <div class="space"></div>

        <ul class="gallerix_medialib_pagination">
            <?php
            $medialib_data = Gallerix::get_medialib_data();
            $pages = (int) $medialib_data->max_num_pages;
            $fpage = isset($_GET["fpage"])  ? (int)$_GET["fpage"]  : 1;

            if ($pages > 1) {
                $i = 1;
                while ($i <= $pages) {
                    ?>
                    <li <?php echo $fpage == $i ? 'class="active" ' : null; ?>><a href="<?php echo "?page=$plugin_page&view=add_multiple&catid=$catid&filter=$filter&fpage=$i"?>"><?php echo $i; ?></a></li>
                    <?php
                    $i++;
                }
            }
            ?>
        </ul>

        <ul class="gallerix_medialib_list">
            <?php $medialib = Gallerix::get_medialib_list(); ?>
            
            <?php foreach ($medialib as $image) : ?>
                <li id="image-<?php echo $image->id; ?>">
                    <?php echo $image->image; ?>
                </li>
            <?php endforeach; ?>
        </ul>
        
        <p class="note">Select one or more images available from your Wordpress Media Library and click Save Changes to add them to Gallerix. Images that does not have Gallerix thumbnail (175px by 114px) will be automatically regenerated.</p>

        <div class="separator"></div>
        <button class="gallerix_save">Save Changes</button>
        <a class="gallerix_cancel" href="?page=<?php echo $plugin_page; ?>&view=list">Cancel</a>
  
        <input type="hidden" name="task" value="add_multiple" />
    </form>
</div>