<?php
global $plugin_page;
$options = Gallerix::get_options();
?>
<!-- Admin Wrapper Start -->
<div class="admin_wrapper">

    <!-- Admin Section Start -->
    <div class="admin_section">

        <!-- Admin Section Header Start -->
        <div class="admin_section_header">
            <h2><?php _e("General Settings", "gallerix"); ?></h2>
            <p><?php _e("Adjust Gallerix general settings", "gallerix"); ?></p>
        </div><!--/admin_section_header -->
        <!-- Admin Section Header End -->

        <!-- Admin Section Body Start -->
        <div class="admin_section_body">
            <form id="gallerix-form-save" action="?page=<?php echo $plugin_page; ?>&view=general" method="POST">

                <div class="admin_section_tabs">
                    <button onclick="return false;" class="other_tab active">General</button>
                    <button onclick="return false;" class="colors_tab">Colors</button>
                </div>

                <!-- Colors -->
                <div class="gallerix_section_colors">    

                    <label>
                        <span><?php _e("Image Box Background", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <input name="boxbg" type="text" class="gallerix_color_picker" value="<?php echo $options->boxbg; ?>" />
                        <p>(<?php _e("Image Box Background", "gallerix"); ?>)</p>
                    </label>

                    <label>
                        <span><?php _e("Navigation Menu Color", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <input name="navcolor" type="text" class="gallerix_color_picker" value="<?php echo $options->navcolor; ?>" />
                        <p>(<?php _e("Navigation Menu Color", "gallerix"); ?>)</p>
                    </label>

                    <label>
                        <span><?php _e("Navigation Menu Hover Color", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <input name="navcolorhover" type="text" class="gallerix_color_picker" value="<?php echo $options->navcolorhover; ?>" />
                        <p>(<?php _e("Navigation Menu Hover Color", "gallerix"); ?>)</p>
                    </label>

                </div>


                <!-- Other -->
                <div class="gallerix_section_other">       

                    <label>
                        <span><?php _e("Default category", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Required!", "gallerix"); ?>)</span><br />
                        <select required="required" name="defaultcat">
                            <option value="0" <?php echo $options->defaultcat == 0 ? "selected" : null ?>><?php _e("All Categories", "gallerix"); ?></option>
                            <?php
                            $categories = Gallerix::get_categories();
                            if ($categories) :
                                foreach ($categories as $category) :
                                    ?>
                                    <option value="<?php echo $category->id; ?>" <?php echo $options->defaultcat == $category->id ? "selected" : null ?>><?php echo $category->title; ?></option>
                                    <?php
                                endforeach;
                            endif;
                            ?>
                        </select>
                        <p>(<?php _e("Images per page", "gallerix"); ?>)</p>
                    </label>

                    <label>
                        <span><?php _e("Images per page", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <input name="perpage" type="text" class="" value="<?php echo $options->perpage; ?>" />
                        <p>(<?php _e("Title text color", "gallerix"); ?>)</p>
                    </label>

                    <label>
                        <span><?php _e("Box Shadow", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <select name="shadow">
                            <option value="0" <?php echo $options->shadow == 0 ? "selected" : null ?>><?php _e("Disable", "gallerix"); ?></option>
                            <option value="1" <?php echo $options->shadow == 1 ? "selected" : null ?>><?php _e("Enable", "gallerix"); ?></option>
                        </select>
                        <p>(<?php _e("Box Shadow", "gallerix"); ?>)</p>
                    </label>

                    <label>
                        <span><?php _e("Image Gloss Effect", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <select name="gloss">
                            <option value="0" <?php echo $options->gloss == 0 ? "selected" : null ?>><?php _e("Disable", "gallerix"); ?></option>
                            <option value="1" <?php echo $options->gloss == 1 ? "selected" : null ?>><?php _e("Enable", "gallerix"); ?></option>
                        </select>
                        <p>(<?php _e("Image Gloss Effect", "gallerix"); ?>)</p>
                    </label>
                    
                    <label>
                        <span><?php _e("Navigation Position", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <select name="navpos">
                            <option value="center" <?php echo $options->navpos == "center" ? "selected" : null ?>><?php _e("Center", "gallerix"); ?></option>
                            <option value="left"   <?php echo $options->navpos == "left"   ? "selected" : null ?>><?php _e("Left", "gallerix"); ?></option>
                            <option value="right"  <?php echo $options->navpos == "right"  ? "selected" : null ?>><?php _e("Right", "gallerix"); ?></option>
                        </select>
                        <p>(<?php _e("Navigation Position", "gallerix"); ?>)</p>
                    </label>

                    <label>
                        <span><?php _e("Lightbox Image Title and Share Links", "gallerix"); ?></span>
                        <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                        <select name="sharedesc">
                            <option value="0" <?php echo $options->sharedesc == 0 ? "selected" : null ?>><?php _e("Disable", "gallerix"); ?></option>
                            <option value="1" <?php echo $options->sharedesc == 1 ? "selected" : null ?>><?php _e("Enable", "gallerix"); ?></option>
                        </select>
                        <p>(<?php _e("Lightbox Image Title and Share Links", "gallerix"); ?>)</p>
                    </label>

                </div>

                <button><?php _e("Save Settings", "gallerix"); ?></button>
                <input type="hidden" name="task" value="save" />
            </form>
            <form method="POST">
                <button><?php _e("Reset Defaults", "gallerix"); ?></button>
                <input type="hidden" name="task" value="reset" />
            </form>
            <button onclick="window.location.href = '?page=<?php echo $plugin_page; ?>';"><?php _e("Cancel", "gallerix"); ?></button>

        </div><!--/admin_section_body-->
        <!-- Admin Section Body End -->

    </div><!--/admin_section -->
    <!-- Admin Section End -->

</div><!--/admin_wrapper-->
<!-- Admin Wrapper End -->