<?php global $plugin_page; ?>
<!-- Admin Wrapper Start -->
<div class="admin_wrapper">

    <!-- Admin Section Start -->
    <div class="admin_section">

        <!-- Admin Section Header Start -->
        <div class="admin_section_header">
            <h2><?php _e("Add / Edit Image", "gallerix"); ?></h2>
            <p><?php _e("Add / Edit Image", "gallerix"); ?></p>
        </div><!--/admin_section_header -->
        <!-- Admin Section Header End -->

        <!-- Admin Section Body Start -->
        <div class="admin_section_body">
            <form action="?page=<?php echo $plugin_page; ?>&view=list" method="POST">
                <?php
                /*
                 *  $image - Post Object ($_REQUEST["id"])
                 *  if $image - update table;
                 *  else - create new post;
                 * 
                 */
                $image = Gallerix::get_image();
                ?>
                <!-- Text Field Start -->
                <label>
                    <span><?php _e("Image Title", "gallerix"); ?></span>
                    <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                    <input name="title" type="text" value="<?php echo $image ? $image->title : ""; ?>" />
                    <p>(<?php _e("Image Title", "gallerix"); ?>)</p>
                </label>
                <!-- Text Field End -->

                <!-- Select Field Start -->
                <label>
                    <span><?php _e("Image Category", "gallerix"); ?></span>
                    <span class="caption_note">(<?php _e("Required!", "gallerix"); ?>)</span><br />
                    <select id="image_category" name="category">
                        <?php
                        $categories = Gallerix::get_categories();
                        $catid = isset($_GET["catid"]) ? (int) $_GET["catid"] : false;
                        foreach ($categories as $category) :
                            if ($catid && !$image) : ?>
                                <option value="<?php echo $category->id; ?>" <?php echo ($category->id == $catid) ? 'selected="selected"' : null; ?>><?php echo htmlspecialchars($category->title); ?></option>
                            <?php else: ?>
                                <option value="<?php echo $category->id; ?>" <?php echo $image && ($category->id == $image->category) ? 'selected="selected"' : null; ?>><?php echo htmlspecialchars($category->title); ?></option>
                            <?php endif; 
                        endforeach;
                        ?>
                    </select>
                    <p>(<?php _e("Select Image Category", "gallerix"); ?>)</p>
                </label>
                <!-- Select Field End -->

                <label>
                    <span><?php _e("Image", "gallerix"); ?></span>
                    <span class="caption_note">(<?php _e("Required!", "gallerix"); ?>)</span><br />
                    <input required="required" name="image" type="text" value="<?php echo $image ? $image->image : ""; ?>" />
                    <p>(<?php _e("Image from the Media Library", "gallerix"); ?>)</p>
                </label>
                
                <!-- Text Field Start -->
                <label>
                    <span><?php _e("Thumb", "gallerix"); ?></span>
                    <span class="caption_note">(<?php _e("Optional.", "gallerix"); ?>)</span><br />
                    <input name="thumb" type="text" value="<?php echo $image ? $image->thumb : ""; ?>" />
                    <p>(<?php _e("If no thumbnail selected, thumb will be generated from the main image.", "gallerix"); ?>)</p>
                </label>
                <!-- Text Field End -->
                
                <?php if ($image) : ?>
                    <input type="hidden" name="update" value="<?php echo $image->id; ?>" />
                <?php endif; ?>
                    
                <input type="hidden" name="task" value="create" />
                <button><?php _e("Save Image", "gallerix"); ?></button>
                
            </form>
            <button onclick="window.location.href = '?page=<?php echo $plugin_page; ?>&view=list';"><?php _e("Cancel", "gallerix"); ?></button>
        </div><!--/admin_section_body-->
        <!-- Admin Section Body End -->

    </div><!--/admin_section -->
    <!-- Admin Section End -->

</div><!--/admin_wrapper-->
<!-- Admin Wrapper End -->