function Gallerix() {
    var glob = {
        categoryid: 0, /* Current images category */
        page: 0, /* Current images page */
        pagesupdate: 1, /* Display, Refresh pagination 0/1 */
        ajax: null, /* Stores the ajax request */
        instance: ".Gallerix",
        lightbox: ".Gallerix_Lightbox",
        blackbox: ".Gallerix_Blackbox",
        imageeq: 0,
        disablehovereffect: 0
    };

    this.init = function(unique) {
        if (typeof unique !== "undefined") {
            glob.instance = ".Gallerix." + unique;
            glob.lightbox = ".Gallerix_Lightbox." + unique;
            glob.blackbox = ".Gallerix_Blackbox." + unique;
        }

        if (typeof gallerixdefaultcat !== "undefined") {
            if (gallerixdefaultcat !== 0) {
                glob.categoryid = gallerixdefaultcat;

                jQuery(glob.instance + " #categoryid-" + glob.categoryid).addClass("active");
            }
        }

        ajax.getImages();
        pagination.bindControls();
        categories.bindControls();
        images.bindControls();
        lightbox.init();
    };

    var helper = {
        loademimages: function(el, callback) {

            if (jQuery(el).get(0).tagName.toLowerCase() === "img") {
                jQuery(el).imagesLoaded(function() {
                    setTimeout(function() {
                        callback();
                        return;
                    }, 10);
                });
            }

            var total = jQuery(el).find("img").length;
            jQuery(el).find("img").each(function() {
                jQuery(this).imagesLoaded(function() {
                    total--;
                    if (total <= 0) {
                        callback();
                        return;
                    }
                });
            });
        },
        isIE8: function() {
            if (navigator.appName !== 'Microsoft Internet Explorer') return false;
            var ua = navigator.userAgent;
            return (ua.indexOf("MSIE 8.0") !== -1) ? true : false;
        }
    };

    var ajax = {
        getImages: function() {
            var data = {
                action: "getImages",
                categoryid: glob.categoryid,
                page: glob.page,
                pagesupdate: glob.pagesupdate
            };

            glob.ajax = jQuery.ajax({
                type: "POST",
                url: ajaxurl,
                data: data,
                beforeSend: function() {
                    if (glob.ajax) {
                        glob.ajax.abort();
                    }
                },
                success: function(data) {
                    images.update(data);
                },
                dataType: "html"
            });
        }
    };

    var images = {
        bindControls: function() {

            jQuery(document).on("click", glob.instance + " .gallerix_content_wrapper ul li", function(event) {
                if (glob.disablehovereffect === 1) return;
                glob.imageeq = jQuery(this).index();
                lightbox.open();
                event.preventDefault();
            });

            if (helper.isIE8() === true) {
                jQuery(glob.instance).on("mouseleave", function(event) {
                    if (glob.disablehovereffect === 1)
                        return;
                    jQuery(glob.instance + " .gallerix_content_wrapper ul li img").stop().fadeTo(250, 1);
                    event.stopPropagation();
                });
                jQuery(document).on("hover", glob.instance + " .gallerix_content_wrapper ul li", function(event) {
                    if (glob.disablehovereffect === 1)
                        return;
                    var th = jQuery(this).find("img");
                    jQuery(glob.instance + " .gallerix_content_wrapper ul li img").stop();
                    jQuery(th).stop().fadeTo(250, 1);
                    jQuery(glob.instance + " .gallerix_content_wrapper ul li img").not(th).stop().fadeTo(250, 0.5);
                    event.stopPropagation();
                });
                return;
            }

            jQuery(glob.instance).on("mouseleave", function(event) {
                if (glob.disablehovereffect === 1) return;
                jQuery(glob.instance + " .gallerix_content_wrapper ul li").stop().fadeTo(250, 1);
                event.stopPropagation();
            });

            jQuery(document).on("hover", glob.instance + " .gallerix_content_wrapper ul li", function(event) {
                if (glob.disablehovereffect === 1) return;
                jQuery(glob.instance + " .gallerix_content_wrapper ul li").stop();
                jQuery(this).fadeTo(250, 1);
                jQuery(glob.instance + " .gallerix_content_wrapper ul li").not(this).fadeTo(250, 0.5);
                event.stopPropagation();
            });
        },
        update: function(data) {
            var html = jQuery.trim(jQuery(data).find("#gallerix-ajax-images").html());
            jQuery(glob.instance + " .gallerix_content_wrapper ul").empty();
            jQuery(html).css({
                opacity: 0
            }).appendTo(glob.instance + " .gallerix_content_wrapper ul");
            images.showAnimate();

            if (glob.pagesupdate === 1) {
                var pagination = jQuery.trim(jQuery(data).find("#gallerix-ajax-pagination").html());
                jQuery(glob.instance + " .gallerix_pagination ul").empty();
                jQuery(pagination).appendTo(jQuery(glob.instance + " .gallerix_pagination ul"));
            }
        },
        hideAnimate: function() {
            var el = glob.instance + " .gallerix_content_wrapper ul li";

            glob.disablehovereffect = 1;

            jQuery(glob.instance + " .gallerix_image_box").css("cursor", "default");

            if (helper.isIE8() === true) {
                jQuery(el).each(function() {
                    var delay = Math.floor(Math.random() * 250) + 1;
                    jQuery(this).find("img").delay(delay).fadeOut(250);
                });
                return;
            }

            jQuery(el).each(function() {
                var delay = Math.floor(Math.random() * 250) + 1;
                jQuery(this).delay(delay).animate({
                    opacity: 0
                }, {
                    duration: 250
                });
            });
        },
        showAnimate: function() {

            helper.loademimages(jQuery(glob.instance + " .gallerix_content_wrapper ul li"), function() {

                glob.disablehovereffect = 0;

                if (helper.isIE8() === true) {
                    jQuery(glob.instance + " .gallerix_content_wrapper ul li").each(function() {
                        var delay = Math.floor(Math.random() * 250) + 1;
                        jQuery(this).find("img").hide().delay(delay).fadeIn(250);
                    });
                    return;
                }

                jQuery(glob.instance + " .gallerix_content_wrapper ul li").each(function() {
                    var delay = Math.floor(Math.random() * 250) + 1;
                    jQuery(this).delay(delay).animate({
                        opacity: 1
                    }, {
                        duration: 250
                    });
                });
            });

        }
    };

    var pagination = {
        bindControls: function() {
            jQuery(document).on("click", glob.instance + " .gallerix_pagination a", function(event) {
                if (jQuery(this).parent().hasClass("active")) {
                    event.preventDefault();
                    return;
                }

                var page = parseInt(jQuery(this).parent().attr("id").replace("gallerixpage-", ""), 10);

                jQuery(glob.instance + " .gallerix_pagination ul li").removeClass("active");
                jQuery(this).parent().addClass("active");

                glob.page = page;
                glob.pagesupdate = 0;
                glob.imageeq = 0;
                images.hideAnimate();
                ajax.getImages();
                event.preventDefault();
            });
        }
    };

    var categories = {
        bindControls: function() {
            jQuery(document).on("click", glob.instance + " .gallerix_top_navigation ul li a", function(event) {

                if (jQuery(this).parent().hasClass("active")) {
                    event.preventDefault();
                    return;
                }

                var catid = parseInt(jQuery(this).parent().attr("id").replace("categoryid-", ""), 10);

                jQuery(glob.instance + " .gallerix_top_navigation ul li").removeClass("active");
                jQuery(this).parent().addClass("active");

                glob.page = 0;
                glob.pagesupdate = 1;
                glob.imageeq = 0;
                glob.categoryid = catid;
                images.hideAnimate();
                ajax.getImages();
                event.preventDefault();
            });
        }
    };
    
    var lightbox = {
        
        init: function(){
            jQuery(glob.blackbox).appendTo("body");
            jQuery(glob.lightbox).appendTo("body");
            
            this.bindControls();
            
            jQuery(window).on("resize", function(){
               if (jQuery(glob.lightbox).is(":visible")) {
                   lightbox.position();
               } 
            });
        },
        
        bindControls: function(){
            jQuery(glob.blackbox).on("click", function(){
               lightbox.close(); 
            });
            
            jQuery(glob.lightbox).find(".gallerix-lightbox-close").on("click", function(e){
                e.preventDefault();
                lightbox.close(); 
            });
            
            jQuery(glob.lightbox).on("mouseenter", function(){
                jQuery(glob.lightbox).find(".gallerix-lightbox-media-controls").stop().fadeTo(250,1);
                
                
                jQuery(glob.lightbox).find(".gallerix-lightbox-media-control-prev").stop().animate({
                    left: "0px"
                }, {
                    easing:"swing",
                    duration: 250
                });
                
                jQuery(glob.lightbox).find(".gallerix-lightbox-media-control-next").stop().animate({
                    right: "0px"
                }, {
                    easing:"swing",
                    duration: 250
                });
                
                jQuery(glob.lightbox).find(".gallerix-lightbox-top").stop().animate({
                    height: "40px"
                }, {
                    easing:"swing",
                    duration: 250,
                    complete: function(){
                    }
                });
            });
            
            jQuery(glob.lightbox).on("mouseleave", function(){
                jQuery(glob.lightbox).find(".gallerix-lightbox-media-controls").stop().fadeTo(250,0);
                
                jQuery(glob.lightbox).find(".gallerix-lightbox-media-control-prev").stop().animate({
                    left: "-50px"
                }, {
                    easing:"swing",
                    duration: 250
                });
                
                jQuery(glob.lightbox).find(".gallerix-lightbox-media-control-next").stop().animate({
                    right: "-50px"
                }, {
                    easing:"swing",
                    duration: 250
                });
                
                jQuery(glob.lightbox).find(".gallerix-lightbox-top").stop().animate({
                    height: "1px"
                }, {
                    easing:"swing",
                    duration: 250,
                    complete: function(){
                    }
                });
            });
            
            
            jQuery(glob.lightbox).find(".gallerix-lightbox-media-control-prev").on("click", function() {
                
                // @todo check animated
                
                glob.imageeq = glob.imageeq - 1;

                if (glob.imageeq < 0) {
                    glob.imageeq = jQuery(glob.instance).find(".gallerix_content_wrapper ul li").length - 1;
                }
                
                lightbox.swap();
            });
            
            jQuery(glob.lightbox).find(".gallerix-lightbox-media-control-next").on("click", function(){
                
                 // @todo check animated
                
                glob.imageeq = glob.imageeq + 1;

                if (glob.imageeq > jQuery(glob.instance).find(".gallerix_content_wrapper ul li").length - 1) {
                    glob.imageeq = 0;
                }
                
                lightbox.swap();
            });
        },
        
        position: function(){
            
            var offsettop = jQuery(document).scrollTop() + jQuery("#wpadminbar").height();
            var top = (jQuery(window).height() / 2 - jQuery(glob.lightbox).outerHeight() / 2) + offsettop;
            if (top < 0) top = 50;
            
            
            jQuery(glob.lightbox).css({
                left: jQuery(window).width() / 2 - jQuery(glob.lightbox).outerWidth() / 2,
                top: top
            });
            
        },
        
        close: function(){
            jQuery(glob.blackbox).hide();
            jQuery(glob.lightbox).hide();
            jQuery(glob.lightbox).find("img").remove();
        },
        
        updateSocials: function(){
            
            var url = window.location.href;
            var img = jQuery(glob.lightbox).find(".gallerix-lightbox-media-image img:last").attr("src");
            
            var fb = "http://www.facebook.com/sharer/sharer.php?u=" + url;            
            jQuery(glob.lightbox).find(".gallerix-lightbox-social-icon.facebook").attr("href", fb);
            
            var tw = "http://twitter.com/home?status=" + url;
            jQuery(glob.lightbox).find(".gallerix-lightbox-social-icon.twitter").attr("href", tw);
            
            var pin = "http://www.pinterest.com/pin/create/button/?url="+url+"&amp;media="+img+"&amp;description="+url;
            jQuery(glob.lightbox).find(".gallerix-lightbox-social-icon.pinterest").attr("href", pin);
            
            var gp = "https://plus.google.com/share?url=" + url;
            jQuery(glob.lightbox).find(".gallerix-lightbox-social-icon.googleplus").attr("href", gp);
            
        },
        
        swap: function(){
            jQuery(glob.blackbox).addClass("loading");
            var $lb  = jQuery(glob.lightbox);
            var $old = jQuery(glob.lightbox).find(".gallerix-lightbox-media-image img:first");
            $lb.fadeTo(250,0, function(){
                
                var image = jQuery(glob.instance).find(".gallerix_content_wrapper li").eq(glob.imageeq).find("a").attr("href");
                var title = jQuery(glob.instance).find(".gallerix_content_wrapper li").eq(glob.imageeq).find("img").attr("alt");
                var image_html = '<img src="' + image + '" alt="' + title + '" />';
                var title_html  = '<p>'+title+'</p>';
                
                jQuery(glob.lightbox + " .gallerix-lightbox-image-title p").remove();
                
                jQuery(image_html).appendTo(glob.lightbox + " .gallerix-lightbox-media-image");
                
                if (title) {
                    jQuery(title_html).appendTo(glob.lightbox + " .gallerix-lightbox-image-title");
                }
                
                var $new = jQuery(glob.lightbox).find(".gallerix-lightbox-media-image img:last");
                $new.imagesLoaded(function(){
                    $old.remove();
                    $lb.fadeTo(250,1);
                    lightbox.position();
                    lightbox.updateSocials();
                    jQuery(glob.blackbox).removeClass("loading");
                });
            });
        },
        
        open: function(){
            jQuery(glob.blackbox).show();
            jQuery(glob.blackbox).addClass("loading");
            
            var image = jQuery(glob.instance).find(".gallerix_content_wrapper li").eq(glob.imageeq).find("a").attr("href");
            var title = jQuery(glob.instance).find(".gallerix_content_wrapper li").eq(glob.imageeq).find("img").attr("alt");
            var image_html  = '<img src="'+image+'" alt="'+title+'" />';
            var title_html  = '<p>'+title+'</p>';
            
            jQuery(glob.lightbox + " .gallerix-lightbox-image-title p").remove();
            
            jQuery(image_html).appendTo(glob.lightbox + " .gallerix-lightbox-media-image");
            
            if (title) {
                jQuery(title_html).appendTo(glob.lightbox + " .gallerix-lightbox-image-title");
            }
            
            jQuery(glob.lightbox).find("img").imagesLoaded(function(){
                lightbox.position();
                lightbox.updateSocials();
                jQuery(glob.lightbox).show();
                jQuery(glob.blackbox).removeClass("loading");
            });
            
        }
    };
    
}

jQuery(document).ready(function() {
    var i = 0;
    while (gallerixinstance[i]) {
        var gallerixunique = gallerixinstance[i].split(",")[0];
        gallerixdefaultcat = gallerixinstance[i].split(",")[1];
        new Gallerix().init(gallerixunique);
        i++;
    }
});